//	PathJoiner.js
//	http://www.pictrix.jp/	Umezawa
//	05.4.4	7:08 PM


var pathObj;
var pathCnt;
var selObj;
var selPnt;
var selLen
var selNum = new Array( );
var flg = new Array( );
var pos = new Array( );
var posL = new Array( );
var posR = new Array( );
var pos1 = new Array( );
var count;
var nextPath;
var nextPnt;
var nextLen;

var baseValX;
var baseValY;
var baseRngY;
var baseRngY;
var baseDiv = 20;
var Index0 = new Array( baseDiv * baseDiv );
var Index1 = new Array( baseDiv * baseDiv );


if (documents.length > 0 && activeDocument.pathItems.length > 0 ){

	pathObj	= activeDocument.pathItems;
	pathCnt	= pathObj.length;
	setFlg( );
	calcBase( );
	setIndex( );

	if ( activeDocument.selection.length > 0 ){

		selcnt = 0;
		for ( i = 0; i < pathCnt; i++ ){
			if ( pathObj[ i ].selected ) selNum[ selcnt++ ] = i;
		}

		for ( i = 0; i < selcnt; i++ ){
			k = selNum[ i ];
			if ( flg[ k ] == 1 ){
				selObj = pathObj[ k ];
				selLen = selObj.pathPoints.length - 1;
				selPnt = -1;
				if ( selObj.pathPoints[ 0 ].selected == PathPointSelection.ANCHORPOINT ) selPnt = 0;
				if ( selObj.pathPoints[ selLen ].selected == PathPointSelection.ANCHORPOINT ) selPnt = selLen;

				if ( selPnt != -1 ){
					flg[ k ] = 2;
					if ( engine( ) ) pathObj[ k ].selected = true;
					else pathObj[ k ].selected = false;
				}
				else pathObj[ k ].selected = false;
			}
		}
	}

	else{

		for ( i = 0; i < pathCnt; i++ ){
			if ( flg[ i ] == 1 ){
				selLen = pathObj[ i ].pathPoints.length - 1;
				sw1 = srhNew( i, 0 );
				sw2 = ( sw1 )? srhNew( i, selLen ) : 0;
				if ( sw1 == 0 || sw2 == 0 ){
					selObj = pathObj[ i ];
					selPnt = ( sw1 == 0 )? 0 : selLen;
					flg[ i ] = 2;
					if ( engine( ) ) pathObj[ i ].selected = true;
				}
			}
		}

		for ( i = 0; i < pathCnt; i++ ){
			if ( flg[ i ] == 1 ){
				selObj = pathObj[ i ];
				selLen = selObj.pathPoints.length - 1;
				selPnt = 0;
				flg[ i ] = 2;
				if ( engine( ) ) pathObj[ i ].selected = true;
			}
		}

	}

	for ( i = pathCnt - 1; i >= 0; i-- ){
		if ( flg[ i ] == 0 ) pathObj[ i ].remove();
	}
}


function setFlg(  )
{
	var i;

	for ( i = 0; i < pathCnt; i++ ){
		if ( pathObj[ i ].closed || pathObj[ i ].locked || pathObj[ i ].hidden || 
			pathObj[ i ].layer.locked || ! pathObj[ i ].layer.visible || pathObj[ i ].guides )
			flg[ i ] = 3;
		else flg[ i ] = 1;
	}
	for ( i = 0; i < baseDiv * baseDiv; i++ ){
		Index0[ i ] = new Array( );
		Index1[ i ] = new Array( );
	}
}


function engine( )
{
	var closept, i, join;

	count = 0;
	pos = new Array( );

	if ( selPnt == 0 ){
		posL[ count ] = selObj.pathPoints[ selPnt ].leftDirection;
		posR[ count ] = selObj.pathPoints[ selPnt ].rightDirection;
	}
	else{
		posL[ count ] = selObj.pathPoints[ selPnt ].rightDirection;
		posR[ count ] = selObj.pathPoints[ selPnt ].leftDirection;
	}

	pos[ count++ ] = pos1 = selObj.pathPoints[ selPnt ].anchor;
	setPos( selObj, selLen, selPnt );

	join = 0;
	while( srhPos( pos[ count - 1 ] ) ) {
		join = 1;
		setPos( pathObj[ nextPath ], nextLen, nextPnt );
	}

	if ( comp( pos1, pos[ count - 1 ] ) ) {
		count--;
		posL[ 0 ] = posL[ count ];
		closept = 1;
		join = 1;
	}
	else closept = 0;

	if ( join ){
		selObj.setEntirePath( pos );
		for ( i = 0; i < count; i++ ){
			selObj.pathPoints[ i ].leftDirection = posL[ i ];
			selObj.pathPoints[ i ].rightDirection = posR[ i ];
		}
		if ( closept ){
			selObj.pathPoints[ count ].remove();
			selObj.closed = true;
		}
	}
	return join;
}



function srhNew( x, n )
{
	var i, tn, p, rg, id;

	p = pathObj[ x ].pathPoints[ n ].anchor;
	rg = calcRange( p );

	for ( i = 0; i < Index0[ rg ].length; i++ ){
		id = Index0[ rg ][ i ];
		if ( id != x && flg[ id ] == 1 ){
			if ( comp( p, pathObj[ id ].pathPoints[ 0 ].anchor ) ) {
				return 1;
			}
		}
	}
	for ( i = 0; i < Index1[ rg ].length; i++ ){
		id = Index1[ rg ][ i ];
		if ( id != x && flg[ id ] == 1 ){
			tn = pathObj[ id ].pathPoints.length - 1;
			if ( comp( p, pathObj[ id ].pathPoints[ tn ].anchor ) ) {
				return 1;
			}
		}
	}
	return 0;
}


function srhPos( p )
{
	var i, n, rg, id;

	rg = calcRange( p );

	for ( i = 0; i < Index0[ rg ].length; i++ ){
		id = Index0[ rg ][ i ];
		if ( flg[ id ] == 1 ){
			n = pathObj[ id ].pathPoints.length - 1;
			if ( comp( p, pathObj[ id ].pathPoints[ 0 ].anchor ) ) {
				nextPath = id;
				nextPnt = 0;
				nextLen = n;
				flg[ id ] = 0;
				return 1;
			}
		}
	}
	for ( i = 0; i < Index1[ rg ].length; i++ ){
		id = Index1[ rg ][ i ];
		if ( flg[ id ] == 1 ){
			n = pathObj[ id ].pathPoints.length - 1;
			if ( comp( p, pathObj[ id ].pathPoints[ n ].anchor ) ) {
				nextPath = id;
				nextPnt = n;
				nextLen = n;
				flg[ id ] = 0;
				return 1;
			}
		}
	}
	return 0;
}


function setPos( path, n, sw )
{
	var i;

	if ( sw == 0 ){
		posR[ count - 1 ] = path.pathPoints[ 0 ].rightDirection;
		for ( i = 1; i <= n; i++ ){
			posL[ count ] = path.pathPoints[ i ].leftDirection;
			posR[ count ] = path.pathPoints[ i ].rightDirection;
			pos[ count++ ] = path.pathPoints[ i ].anchor;
		}
	}
	else{
		posR[ count - 1 ] = path.pathPoints[ n ].leftDirection;
		for ( i = n - 1; i >= 0; i-- ){
			posL[ count ] = path.pathPoints[ i ].rightDirection;
			posR[ count ] = path.pathPoints[ i ].leftDirection;
			pos[ count++ ] = path.pathPoints[ i ].anchor;
		}
	}
}

function comp( s, t )
{
	if ( s[ 0 ] == t[ 0 ] && s[ 1 ] == t[ 1 ] ) return 1;
	return 0;
}




function calcRange( p )
{
	return Math.floor( ( p[ 1 ] - baseValY ) / baseRngY ) * baseDiv + Math.floor( ( p[ 0 ] - baseValX ) / baseRngX );
}


function calcBase( )
{
	baseValX = Math.floor( activeDocument.geometricBounds[ 0 ] - 2.0 );
	baseRngX = ( activeDocument.geometricBounds[ 2 ] - activeDocument.geometricBounds[ 0 ] ) / baseDiv;
	baseRngX = Math.floor( baseRngX ) + 2.0;
	baseValY = Math.floor( activeDocument.geometricBounds[ 3 ] - 2.0 );
	baseRngY = ( activeDocument.geometricBounds[ 1 ] - activeDocument.geometricBounds[ 3 ] ) / baseDiv;
	baseRngY = Math.floor( baseRngY ) + 2.0;
}


function setIndex( )
{
	var i, rg, n;
	
	for ( i = 0; i < pathCnt; i++ ){
		if ( flg[ i ] == 1 ){
			rg = calcRange( pathObj[ i ].pathPoints[ 0 ].anchor );
			Index0[ rg ].push( i );
			n = pathObj[ i ].pathPoints.length - 1;
			rg = calcRange( pathObj[ i ].pathPoints[ n ].anchor );
			Index1[ rg ].push( i );
		}
	}
}






